﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Core.Dtos;
using Core.Entities;

namespace Assembler
{
    public static class AutoMapperConfig
    {
        private static bool s_isInit = false;

        public static void CreateMappings()
        {
            if (s_isInit)
                return;
            s_isInit = true;


            AutoMapper.Mapper.CreateMap<MotorPolicy, MotorPolicyDto>();
            AutoMapper.Mapper.CreateMap<MotorPolicyDto, MotorPolicy>()
                      .ForMember(x => x.Id, opt => opt.Condition(x => !x.IsSourceValueNull && !x.SourceValue.Equals(0)))
                      .ForMember(x => x.Person, opt => opt.Ignore())
                      .ForMember(x => x.PersonID, opt => opt.Condition(x => !x.IsSourceValueNull && !x.SourceValue.Equals(0)));

            AutoMapper.Mapper.CreateMap<Person, PersonDto>().MaxDepth(1);
            AutoMapper.Mapper.CreateMap<PersonDto, Person>()
                      .ForMember(x => x.Id, opt => opt.Condition(x => !x.IsSourceValueNull && !x.SourceValue.Equals(0)));

            AutoMapper.Mapper.CreateMap<Policy, PolicyDto>();
            AutoMapper.Mapper.CreateMap<PolicyDto, Policy>()            
                      .ForMember(x => x.Id, opt => opt.Condition(x => !x.IsSourceValueNull && !x.SourceValue.Equals(0)))
                      .ForMember(x => x.Person, opt => opt.Ignore())
                      .ForMember(x => x.PersonID, opt => opt.Condition(x => !x.IsSourceValueNull && !x.SourceValue.Equals(0)));
        }
    }
}
