﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Runtime.Serialization;
using System.Text;
using System.Threading.Tasks;

namespace Core.Dtos
{
    [Serializable]
    [DataContract] 
    public class BaseDto<TId>
    {
        [IgnoreDataMember]
        public virtual string IdName
        {
            get
            {
                return "Id";
            }
        }

        [IgnoreDataMember]
        public TId IdValue
        {
            get
            {
                object id = this.GetType().GetProperty(IdName).GetValue(this, null);
                return (TId)Convert.ChangeType(id, typeof(TId));
            }
        }
    }
}
