using System;
using System.Collections.Generic;
using System.Runtime.Serialization;

namespace Core.Dtos
{
	[Serializable]
	[DataContract]
    public partial class PolicyDto : BaseDto<int>
	{
		/// <summary>Parameterless constructor (important for serialization)</summary>
		public PolicyDto()
		{
		}
				
		// ********************************************************************************
		// *** Primitive properties *******************************************************
		// ********************************************************************************		
		[DataMember] public int Id { get; set; }
		[DataMember] public long Number { get; set; }
		[DataMember] public int PersonID { get; set; }


		// ********************************************************************************
		// *** Complex properties *********************************************************
		// ********************************************************************************
        public virtual string PersonName { get; set; }
	
		// ********************************************************************************
		// *** Navigation properties ******************************************************
		// ********************************************************************************
		[DataMember] public PersonDto Person { get; set; }

	}
}

