﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;

namespace Core.Messages
{
    /// <summary>
    /// BaseRequest is used to implement the Request-Response pattern.
    /// All methodes in the Service layer should have 1 parameter that inherits from this class.
    /// </summary>
    /// <typeparam name="T"></typeparam>
    public class BaseRequest<T>
    {       
        public BaseRequest(T value)
        {
            this.Value = value;
        }

        public BaseRequest()
        {
        }

        [DataMember()]
        public T Value;       
    }
}
