﻿using System;
using System.Collections;
using System.Collections.Generic;

namespace Core.Messages
{
    public class ListResponse<T> : BaseResponse
    {
     
        public IList<T> List { get; set; }

        public IList JsonList { get; set; }

        public int PageNumber;
        
        public int PageSize;
        
        public int PagesCount
        {
            get
            {
                if (PageSize == 0) return 0;
                return (int)Math.Ceiling((decimal)RowsCount/ PageSize);
            }
        }
        
        public int RowsCount;
    }
}
