﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Linq.Expressions;
using System.Text;
using Core.Entities;
using Library.Extensions;

namespace Core.Queries
{   
    public class PolicyQuery : BaseQuery<Policy>
    {
        public string Id {get;set;}
        public string Number {get;set;}
        public string Name {get;set;}

        public override Expression<Func<Policy, bool>> ToExpression()
        {                                
            int intValue;
            long longValue;

            Expression<Func<Policy, bool>> predicate = x => true;
            if (!string.IsNullOrWhiteSpace(Id))
            {
                intValue = Convert.ToInt32(Id);
                predicate = x => x.Id == intValue;
            }
                            
            if (!string.IsNullOrWhiteSpace(Number))
            {
                longValue = Convert.ToInt64(Number);
                predicate = predicate.And(x => x.Number == longValue);
            }

            if (!string.IsNullOrWhiteSpace(Name))
                predicate = predicate.And(x => x.Person.Name.StartsWith(Name));

            return predicate;
        }       
    }
}
