﻿using System;
using System.Security.Principal;
using System.Net;

namespace Library.Web.Export
{
    [Serializable()]
    public class CustomReportCredentials : Microsoft.Reporting.WebForms.IReportServerCredentials
    {
        #region properties

        // local variable for network credential.
        private string _UserName;
        private string _PassWord;
        private string _DomainName;

        #endregion

        #region c-tors

        public CustomReportCredentials(string UserName, string PassWord, string DomainName)
        {
            _UserName = UserName;
            _PassWord = PassWord;
            _DomainName = DomainName;
        }

        #endregion

        #region implements base class

        public WindowsIdentity ImpersonationUser
        {
            get { return null; // not use ImpersonationUser
            }
        }

        public ICredentials NetworkCredentials
        {
            get
            {

                // use NetworkCredentials
                return new NetworkCredential(_UserName,
                                             _PassWord, _DomainName);
            }
        }

        public bool GetFormsCredentials(out Cookie authCookie, out string user, out string password, out string authority)
        {

            // not use FormsCredentials unless you have implements a custom autentication.
            authCookie = null;
            user = password = authority = null;
            return false;
        }

        #endregion

        #region public methods

        #endregion
    }
}
