using System.Data;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.IO;
using OfficeOpenXml;
using OfficeOpenXml.Style;

namespace Library.Web.UI
{
    /// 
    /// This class provides a method to write a dataset to the HttpResponse as
    /// an excel file. 
    /// 
    public class ExcelExport
    {
        public static void ExportDataSetToExcel(DataSet ds, string filename)
        {               
                HttpResponse response = HttpContext.Current.Response;
                DataTable tbl = ds.Tables[0];

                ExcelPackage pck = new OfficeOpenXml.ExcelPackage();
                ExcelWorksheet ws = pck.Workbook.Worksheets.Add("List");
                ws.Cells["A2"].LoadFromDataTable(tbl, false);
                response.Clear();
                response.ContentType = "application/vnd.openxmlformats-officedocument.spreadsheetml.sheet";
                response.AddHeader("content-disposition", "attachment;  filename=MailingList.xlsx");
                response.BinaryWrite(pck.GetAsByteArray());
                response.End();
        }

        public static byte[] GetExcelAsByteArray(DataTable tbl)
        {                    
            ExcelPackage pck = new OfficeOpenXml.ExcelPackage();
            ExcelWorksheet ws = pck.Workbook.Worksheets.Add("Report 0");

            if(tbl.Rows.Count > 0)
                ws.Cells["A2"].LoadFromDataTable(tbl, false);

            //Header Titles
            string alphabet  = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
            int i=0;
            foreach (DataColumn column in tbl.Columns)
            {
                ws.Cells[alphabet[i].ToString() + "1"].Value = column.ColumnName;
                i++;
            }
            				
            ws.Cells["A1"].AutoFitColumns();
            return pck.GetAsByteArray();
        }        
    }
}