﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Library.Helpers
{
    public class ReportUtil
    {
        public static void RenderPdf(byte[] reportBytes, string fileName)
        {
            Render(reportBytes, fileName, ReportFormatType.Pdf);
        }

        /// <summary>
        /// Utility method to export a files on a web page
        /// </summary>
        /// <param name="reportBytes"></param>
        /// <param name="fileName"></param>
        /// <param name="formatType"></param>
        public static void Render(byte[] reportBytes, string fileName, ReportFormatType formatType)
        {            
            System.Web.HttpContext.Current.Response.Expires = 5;
            System.Web.HttpContext.Current.Response.ClearContent();
            System.Web.HttpContext.Current.Response.ClearHeaders();
            System.Web.HttpContext.Current.Response.ContentType = "application/" + formatType;
            System.Web.HttpContext.Current.Response.AppendHeader("Content-Disposition", "attachment; filename=" + fileName + "." + ReportFormatConverter.ToFileExtension(formatType));
            System.Web.HttpContext.Current.Response.BinaryWrite(reportBytes);
            System.Web.HttpContext.Current.Response.Flush();
            System.Web.HttpContext.Current.Response.Close();         
        }

        public static void RenderPdf(byte[] reportBytes)
        {
            string fileName = "report_file";
            RenderPdf(reportBytes, fileName);
        }
    }
}
