﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;
using Library.Messages;
using System.ServiceModel.Web;

namespace Core.IServices
{    
    [ServiceContract()]
    public interface IBaseService<TId, TDto, TQuery>
    {
        [OperationContract()]        
        [WebGet(UriTemplate = "/{id}")]
        BaseResponse<TDto> FindById(string id);

        [OperationContract()]        
        [WebInvoke(UriTemplate = "/query", Method = "POST")]
        ListResponse<TDto> FindBy(TQuery query);

        [OperationContract()]        
        [WebInvoke(UriTemplate = "/items", Method = "POST")]
        BaseResponse<TId> Add(TDto request);

        [OperationContract()]        
        [WebInvoke(UriTemplate = "/items", Method = "PUT")]
        BaseResponse Edit(TDto request);

        [OperationContract()]        
        [WebInvoke(UriTemplate = "/{id}", Method = "DELETE")]
        BaseResponse Delete(string id);
    }
}
