﻿

using Core.Dtos;

namespace Core.Dtos
{
	/// <summary>
	/// Currently only supports Navigation properties, not complex properties.
	/// The .ForMember() calls prevent triggering lazy loading EF navigation properties.  If an EntityReference or
	/// EntityCollection has not been loaded, it will be ignored.
	/// </summary>
	public static class AutoMapperConfig
	{
		private static bool s_isInit = false;
		
		public static void CreateMappings()
		{
			if (s_isInit)
				return;
			s_isInit = true;

			// AutoMapper config for MotorPolicy => MotorPolicyDto
			AutoMapper.Mapper.CreateMap<MotorPolicy, MotorPolicyDto>();
				
			// Reverse config (dto => entity)
			AutoMapper.Mapper.CreateMap<MotorPolicyDto, MotorPolicy>();


				
			// Reverse config (dto => entity)
			AutoMapper.Mapper.CreateMap<PersonDto, Person>();


				
			// Reverse config (dto => entity)
			AutoMapper.Mapper.CreateMap<PolicyDto, Policy>();

		}
	}
}

