﻿

using System;
using System.Collections.Generic;

namespace Core.Dtos
{

	public static class DtoExtensionMethods
	{
		/// <summary>
		/// Easily create DTO objects from actual domain entity objects
		/// </summary>
		public static MotorPolicy[] ToEntities(this IEnumerable<MotorPolicyDto> dtos)
		{
			return AutoMapper.Mapper.Map<IEnumerable<MotorPolicyDto>, MotorPolicy[]>(dtos);
		}
		
		public static IEnumerable<MotorPolicyDto> StripCycles(this IEnumerable<MotorPolicyDto> dtos)
		{
			foreach(MotorPolicyDto dto in dtos)
				dto.StripCycles();
			return dtos;
		}


		public static MotorPolicy ToEntity(this MotorPolicyDto dto)
		{
			return AutoMapper.Mapper.Map<MotorPolicyDto, MotorPolicy>(dto);
		}
		
		/// <summary>
		/// Easily create DTO objects from actual domain entity objects
		/// </summary>
		public static Person[] ToEntities(this IEnumerable<PersonDto> dtos)
		{
			return AutoMapper.Mapper.Map<IEnumerable<PersonDto>, Person[]>(dtos);
		}
		
		public static IEnumerable<PersonDto> StripCycles(this IEnumerable<PersonDto> dtos)
		{
			foreach(PersonDto dto in dtos)
				dto.StripCycles();
			return dtos;
		}


		public static Person ToEntity(this PersonDto dto)
		{
			return AutoMapper.Mapper.Map<PersonDto, Person>(dto);
		}
		
		/// <summary>
		/// Easily create DTO objects from actual domain entity objects
		/// </summary>
		public static Policy[] ToEntities(this IEnumerable<PolicyDto> dtos)
		{
			return AutoMapper.Mapper.Map<IEnumerable<PolicyDto>, Policy[]>(dtos);
		}
		
		public static IEnumerable<PolicyDto> StripCycles(this IEnumerable<PolicyDto> dtos)
		{
			foreach(PolicyDto dto in dtos)
				dto.StripCycles();
			return dtos;
		}


		public static Policy ToEntity(this PolicyDto dto)
		{
			return AutoMapper.Mapper.Map<PolicyDto, Policy>(dto);
		}
		
	}
}

