using System;
using System.Linq;
using System.Linq.Expressions;
using System.Collections.Generic;
using System.ComponentModel;
using Hyper.ComponentModel;
using Loef;
using Core.Dtos;

namespace Core
{
	[TypeDescriptionProvider(typeof(HyperTypeDescriptionProvider))]
	public partial class MotorPolicy  : Policy
	{		
	
		public MotorPolicyDto ToDto()
		{
			return AutoMapper.Mapper.Map<MotorPolicy, MotorPolicyDto>(this);
		}
						
		private static readonly PropertyDescriptorCollection s_properties = TypeDescriptor.GetProperties(typeof (MotorPolicy));

		public void ApplyValues(IEnumerable<KeyValuePair<string, object>> values, bool throwOnBadProp = false)
		{
			foreach(KeyValuePair<string, object> pair in values)
			{
				try
				{
					PropertyDescriptor prop = s_properties[pair.Key];
					prop.SetValue(this, pair.Value);
				}
				catch (Exception)
				{
					if (throwOnBadProp)
						throw;
				}
			}
		}
		
		
		// ********************************************************************************
		// *** Include chain helpers ******************************************************
		// ********************************************************************************
		
		public class IncludeChain : IncludeChainBase
		{
		}
		
		public static readonly IncludeChain s_includes = new IncludeChain();
	}
}	

