using System;
using System.Linq;
using System.Linq.Expressions;
using System.Collections.Generic;
using System.ComponentModel;
using Hyper.ComponentModel;
using Loef;
using Core.Dtos;

namespace Core
{
	[TypeDescriptionProvider(typeof(HyperTypeDescriptionProvider))]
	public partial class Person 
	{		
	
		public PersonDto ToDto()
		{
			return AutoMapper.Mapper.Map<Person, PersonDto>(this);
		}
						
		private static readonly PropertyDescriptorCollection s_properties = TypeDescriptor.GetProperties(typeof (Person));

		public void ApplyValues(IEnumerable<KeyValuePair<string, object>> values, bool throwOnBadProp = false)
		{
			foreach(KeyValuePair<string, object> pair in values)
			{
				try
				{
					PropertyDescriptor prop = s_properties[pair.Key];
					prop.SetValue(this, pair.Value);
				}
				catch (Exception)
				{
					if (throwOnBadProp)
						throw;
				}
			}
		}
		
		
		// ********************************************************************************
		// *** Include chain helpers ******************************************************
		// ********************************************************************************
		
		public class IncludeChain : IncludeChainBase
		{
			private static readonly string _Policies = "Policies";
			public Policy.IncludeChain Policies
			{
				get { return Chain<Policy.IncludeChain>(_Policies); }
			}
			
		}
		
		public static readonly IncludeChain s_includes = new IncludeChain();
	}
}	

