﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Runtime.Serialization;
using Lib.Query;

namespace Core.Queries
{
    [Serializable()]
    public class PersonQuery : IBaseQuery<Person>
    {
        public string Name { get; set; }
        
        public LiteQuery<Person> ToLiteQuery()
        {
            LiteQuery<Person> q = new LiteQuery<Person>();
            if(!string.IsNullOrWhiteSpace(Name))
                q.Add(x => x.Name, CriteriaOperator.Equal, Name);

            return q;            
        }
    }
}
