﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Lib.Query;

namespace Core.Queries
{
    public class PolicyQuery : IBaseQuery<Policy>
    {
        public string Id {get;set;}
        public string Number {get;set;}
        public string Name {get;set;}

        public LiteQuery<Policy> ToLiteQuery()
        {
            LiteQuery<Policy> q = new LiteQuery<Policy>();

            if (!string.IsNullOrWhiteSpace(Id))
                q.Add(x => x.Id, CriteriaOperator.Equal, Convert.ToInt32(Id));

            if (!string.IsNullOrWhiteSpace(Number))
                q.Add(x => x.Number, CriteriaOperator.Equal, Convert.ToInt64(Number));

            if (!string.IsNullOrWhiteSpace(Name))
                q.Add(x => x.Person.Name, CriteriaOperator.Like, Name);

            return q;
        }
    }
}
