﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using StructureMap.Configuration.DSL;
using DataAccess.EntityFramework;
using System.Data.Objects;
using Core.IRepository;
using StructureMap;
using Library.Structuremap;
using System.Configuration;

namespace Factory
{
    public class EntityFrameworkRegistry : Registry
    {
        public EntityFrameworkRegistry(InstanceScope contextLifecycle)
        {                         
            For<ObjectContext>().LifecycleIs(StructuremapHelper.GetLifecycle(contextLifecycle)).Use<InsuranceSampleEntities>().Ctor<string>().Is(ConfigurationManager.ConnectionStrings["InsuranceSampleEntities"].ConnectionString);

            For<IPersonRepository>().Use<PersonRepository>();
            For<IPolicyRepository>().Use<PolicyRepository>();
        }
    }
}
