﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using StructureMap.Configuration.DSL;
using Library.NHibernate;
using NHibernate;
using Library.UnitOfWork;
using Core.IRepository;
using DataAccess.NHibernate;
using StructureMap;
using Library.Structuremap;

namespace Factory
{
    public class NHibernateRegistry : Registry
    {
        public NHibernateRegistry(InstanceScope contextLifecycle)
        {
            For<IUnitOfWork>().Use<NHUnitOfWork>();
            ISessionFactory factory = NHSessionFactory.BuildSessionFactory();
            For<ISession>().LifecycleIs(StructuremapHelper.GetLifecycle(contextLifecycle)).Use(factory.OpenSession());

            For<IPersonRepository>().Use<PersonRepository>();
            For<IPolicyRepository>().Use<PolicyRepository>();
        }
    }
}
