﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using NHibernate;
using Library.UnitOfWork;
using Library.Domain;

namespace Library.NHibernate
{
    public class NHUnitOfWork : IUnitOfWork 
    {
        protected ISession NHContext;
        public NHUnitOfWork(ISession nHContext)
        {
            this.NHContext = nHContext;
        }
                  
        public void RegisterAmended(IEntity entity, IUnitOfWorkRepository unitofWorkRepository)
        {
            NHContext.SaveOrUpdate(entity);
        }

        public void RegisterNew(IEntity entity, IUnitOfWorkRepository unitofWorkRepository)
        {
            NHContext.Save(entity);
        }

        public void RegisterRemoved(IEntity entity, IUnitOfWorkRepository unitofWorkRepository)
        {
            NHContext.Delete(entity);
        }   

        public void Commit()
        {
            using (ITransaction transaction = NHContext.BeginTransaction())
            {
                try
                { transaction.Commit(); }
                catch (Exception ex)
                {
                    transaction.Rollback();
                    throw;
                }
            }
        }
    }
}