﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using StructureMap;
using StructureMap.Pipeline;

namespace Library.Structuremap
{
    public class StructuremapHelper
    {
        public static ILifecycle GetLifecycle(InstanceScope instanceScope)
        {
            switch (instanceScope)
            {
                case InstanceScope.PerRequest: return null;
                case InstanceScope.Singleton: return new SingletonLifecycle();
                case InstanceScope.HttpContext: return new HttpContextLifecycle();
                case InstanceScope.ThreadLocal: return new ThreadLocalStorageLifecycle();
                case InstanceScope.Hybrid: return new HybridLifecycle();
                case InstanceScope.HttpSession: return new HttpSessionLifecycle();
                case InstanceScope.HybridHttpSession: return new HybridSessionLifecycle();
                case InstanceScope.Unique: return new UniquePerRequestLifecycle();
            }

            throw new Exception("GetLifecycle");
        }
    }
}
