﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using Core.IServices;
using System.ServiceModel.Description;
using System.ServiceModel;
using System.Configuration;
using Core;
using Library.Messages;

namespace ProxyServices
{
    public class PolicyProxyService : ClientBase<IPolicyService>, IPolicyService
    {
        public PolicyProxyService()
            : base(new WebHttpBinding(), new EndpointAddress(ConfigurationManager.AppSettings["WcfUrl"] + @"/Policy.svc"))
        {
            this.Endpoint.Behaviors.Add(new WebHttpBehavior());
        }

        public BaseResponse<Policy> FindById(string id)
        {
            return base.Channel.FindById(id);
        }

        public BaseResponse<int> Add(Core.Policy request)
        {
            return base.Channel.Add(request);
        }

        public BaseResponse Edit(Core.Policy request)
        {
            return base.Channel.Edit(request);
        }

        public BaseResponse Delete(string id)
        {
            return base.Channel.Delete(id);
        }

        public ListResponse<Policy> FindBy(Core.Queries.PolicyQuery query)
        {
            return base.Channel.FindBy(query);
        }

        public System.IO.Stream GenerateDocument(string id)
        {
            return base.Channel.GenerateDocument(id);
        }
    }
}
